package com.rjconsultores.ventaboletos.relatorios.impl;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;

import com.rjconsultores.ventaboletos.relatorios.utilitarios.ArrayDataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

public class RelatorioEstoque extends Relatorio {

	public RelatorioEstoque(Map<String, Object> parametros, Connection conexao) throws Exception
	{
		super(parametros, conexao);

		this.setCustomDataSource(new ArrayDataSource(this) {

			public void initDados() throws Exception {
				Connection conexao = this.relatorio.getConexao();
				Map<String, Object> parametros = this.relatorio.getParametros();
				String sql = getSql();
				
				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql);

				ResultSet rset = stmt.executeQuery();

				while (rset.next()) {
					Map<String, Object> dataResult = new HashMap<String, Object>();
					dataResult.put("aidf", rset.getString("aidf"));
					dataResult.put("empresa", rset.getString("nombempresa"));
					dataResult.put("estacao", rset.getString("estacao"));
					dataResult.put("agencia", rset.getString("nombpuntoventa"));
					dataResult.put("serie", rset.getString("serie"));
					dataResult.put("forminicio", rset.getString("forminicial"));
					dataResult.put("formfinal", rset.getString("formfinal"));
					dataResult.put("estado", rset.getString("nombestado"));
					dataResult.put("tipo", rset.getString("tipo"));
					this.dados.add(dataResult);
				}

				this.resultSet = rset;
			}
		});
	}

	@Override
	protected void processaParametros() throws Exception {
	}

	private String getSql() {
		StringBuilder sql = new StringBuilder();			
		sql.append(" select dab.aidf_id as aidf, e.nombempresa, p.nombpuntoventa, dab.NUMSERIEPREIMPRESA as serie, es.descestacion as estacao, tp.desctipo as tipo, ");
		sql.append(" case  when dab.STATUSOPERACION = 0 then dab.NUMFOLIOINICIAL else coalesce(fp.FOLIOPREIMPRESO,dab.NUMFOLIOINICIAL) end as forminicial, dab.NUMFOLIOFINAL as formfinal, ");
		sql.append(" est.nombestado, ar.descarticulo ");
		sql.append(" from abasto_boleto ab ");
		sql.append(" inner join empresa e on e.empresa_id = ab.empresa_id and ab.ACTIVO = 1 ");
		sql.append(" inner join det_abasto_boleto dab on dab.abastoboleto_id = ab.abastoboleto_id and dab.ACTIVO = 1 ");
	    sql.append(" inner join punto_venta p on p.puntoventa_id = ab.puntoventa_id and p.ACTIVO = 1 ");
	    sql.append(" left  join TIPO_PTOVTA tp on tp.TIPOPTOVTA_ID = p.TIPOPTOVTA_ID and tp.ACTIVO = 1 ");
		sql.append(" inner join estacion es on es.ESTACION_ID = ab.ESTACION_ID ");
		sql.append(" inner join ARTICULO ar on ar.ARTICULO_ID = ab.ARTICULO_ID ");
		sql.append(" left  join FOLIO_PREIMPRESO fp on fp.AIDF_ID = dab.AIDF_ID and fp.EMPRESA_ID = e.EMPRESA_ID and fp.ESTACION_ID = ab.ESTACION_ID and fp.activo = 1 ");
        sql.append(" inner join aidf ai on ai.aidf_id =dab.aidf_id ");
        sql.append(" inner join estado est on est.estado_id = ai.ESTADO_ID ");

		sql.append(" where ");
		sql.append(" dab.statusoperacion in (0,1) and dab.activo = 1 and ab.activo = 1 ");
		if(parametros.get("EMPRESA_ID") != null){
			sql.append(" and e.empresa_id = ").append(parametros.get("EMPRESA_ID"));
		}			
		if(parametros.get("NUMPUNTOVENTA") != null){
			sql.append(" and ab.puntoventa_id in(").append(parametros.get("NUMPUNTOVENTA")).append(") ");
		}	
		sql.append(" order by e.nombempresa, p.nombpuntoventa,es.descestacion, ar.descarticulo, forminicial");
		
		return sql.toString();
				
		
	}

}
