
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;

import com.rjconsultores.ventaboletos.entidad.ConfTotem;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.service.ConfTotemService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 *
 * @author Wallace
 */
@Controller("busquedaConfTotemController")
@Scope("prototype")
public class BusquedaConfTotemController extends MyGenericForwardComposer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@Autowired
	private ConfTotemService confTotemService;
	private Checkbox chkPermitirTecladoAlfaNumerico;
	private Checkbox chkPermitirVenda;
	private Checkbox chkTituloInicial;
	private Checkbox chkSeguroTabela;
	private Checkbox chkPagamentoMultiempresaBPe;
	private Checkbox chkPermitirImpressao;
	private Checkbox chkPermitirReserva;
	private Checkbox chktrabalhaComParcelamento;
	private Checkbox chkImprimeComprovanteCartaoEmpresaCorrida;
	private Checkbox chktListarPassageiroUltimaPoltrona;
	private static Logger log = Logger.getLogger(BusquedaConfTotemController.class);
	private MyListbox empresaList;
	@Autowired
	private EmpresaService empresaService;
	private List<Empresa> lsEmpresa;
	private Combobox cmbEmpresa;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsEmpresa = empresaService.obtenerTodos();

		refreshLista();
	}

	private void refreshLista() {

		List<ConfTotem> lista = confTotemService.obtenerTodos();

		if (lista.size() == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("customController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
				log.error(ex);
			}
		} else {
			Map<String, String> map = new HashMap<String, String>();
			for (ConfTotem confTotem : lista) {
				map.put(confTotem.getChave(), confTotem.getValor());
			}

			List<Empresa> lsEmpresas = new ArrayList<Empresa>();
			if(StringUtils.isNotBlank(map.get("empresasParaVenda"))) {
				String[] empresas = map.get("empresasParaVenda").split(",");

				for (int i = 0; i < empresas.length; i++) {
					lsEmpresas.add(empresaService.obtenerID(Integer.valueOf(empresas[i])));
				}
			}
	
			chkPermitirTecladoAlfaNumerico.setChecked(StringUtils.isBlank(map.get("isAlphaNumericKeyboard")) ? false : Boolean.parseBoolean(map.get("isAlphaNumericKeyboard")));
			chkPermitirVenda.setChecked(StringUtils.isBlank(map.get("isVendaHabilitado")) ? false : Boolean.parseBoolean(map.get("isVendaHabilitado")));
			chkPermitirImpressao.setChecked(StringUtils.isBlank(map.get("isImpressaoHabilitado")) ? false : Boolean.parseBoolean(map.get("isImpressaoHabilitado")));
			chkPermitirReserva.setChecked(StringUtils.isBlank(map.get("isReservaHabilitado")) ? false : Boolean.parseBoolean(map.get("isReservaHabilitado")));
			chkTituloInicial.setChecked(StringUtils.isBlank(map.get("isTituloInicialDesabilitado")) ? false : Boolean.parseBoolean(map.get("isTituloInicialDesabilitado")));
			chkSeguroTabela.setChecked(StringUtils.isBlank(map.get("isSeguroTabelaViraOpcional")) ? false : Boolean.parseBoolean(map.get("isSeguroTabelaViraOpcional")));
			chkPagamentoMultiempresaBPe.setChecked(StringUtils.isBlank(map.get("isPagamentoMultiempresaBPe")) ? false : Boolean.parseBoolean(map.get("isPagamentoMultiempresaBPe")));
			chkImprimeComprovanteCartaoEmpresaCorrida.setChecked(StringUtils.isBlank(map.get("isImprimeComprovanteCartaoEmpresaCorrida")) ? false : Boolean.parseBoolean(map.get("isImprimeComprovanteCartaoEmpresaCorrida")));
			chktrabalhaComParcelamento.setChecked(StringUtils.isBlank(map.get("trabalhaComParcelamentoCartaoCredito")) ? false : Boolean.parseBoolean(map.get("trabalhaComParcelamentoCartaoCredito")));
			chktListarPassageiroUltimaPoltrona.setChecked(StringUtils.isBlank(map.get("listarPassageiro")) ? false : Boolean.parseBoolean(map.get("listarPassageiro")));

			empresaList.setData(lsEmpresas);

		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	@SuppressWarnings("unchecked")
	public void onClick$buttonSalvar(Event ev) throws InterruptedException {

		try {

			ConfTotem novoItem = new ConfTotem();
			novoItem.setActivo(Boolean.TRUE);
			novoItem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			novoItem.setFecmodif(new Date());

			List<ConfTotem> lista = confTotemService.obtenerTodos();

			Map<String, ConfTotem> map = new HashMap<String, ConfTotem>();
			for (ConfTotem confTotem : lista) {
				map.put(confTotem.getChave(), confTotem);
			}

			ConfTotem confTotem = map.get("isAlphaNumericKeyboard");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkPermitirTecladoAlfaNumerico.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isAlphaNumericKeyboard");
				novoItem.setValor(String.valueOf(chkPermitirTecladoAlfaNumerico.isChecked()));
				confTotemService.suscribir(novoItem);

			}

			confTotem = map.get("isVendaHabilitado");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkPermitirVenda.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isVendaHabilitado");
				novoItem.setValor(String.valueOf(chkPermitirVenda.isChecked()));
				confTotemService.suscribir(novoItem);
			}

			confTotem = map.get("isImpressaoHabilitado");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkPermitirImpressao.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isImpressaoHabilitado");
				novoItem.setValor(String.valueOf(chkPermitirImpressao.isChecked()));

				confTotemService.suscribir(novoItem);
			}

			confTotem = map.get("isReservaHabilitado");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkPermitirReserva.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isReservaHabilitado");
				novoItem.setValor(String.valueOf(chkPermitirReserva.isChecked()));
				novoItem.setFecmodif(new Date());
				novoItem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("isTituloInicialDesabilitado");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkTituloInicial.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isTituloInicialDesabilitado");
				novoItem.setValor(String.valueOf(chkTituloInicial.isChecked()));
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("isSeguroTabelaViraOpcional");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkSeguroTabela.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("chkSeguroTabela");
				novoItem.setValor(String.valueOf(chkSeguroTabela.isChecked()));
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("isPagamentoMultiempresaBPe");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkPagamentoMultiempresaBPe.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isPagamentoMultiempresaBPe");
				novoItem.setValor(String.valueOf(chkPagamentoMultiempresaBPe.isChecked()));
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("isImprimeComprovanteCartaoEmpresaCorrida");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chkImprimeComprovanteCartaoEmpresaCorrida.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("isImprimeComprovanteCartaoEmpresaCorrida");
				novoItem.setValor(String.valueOf(chkImprimeComprovanteCartaoEmpresaCorrida.isChecked()));
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("trabalhaComParcelamentoCartaoCredito");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chktrabalhaComParcelamento.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("trabalhaComParcelamentoCartaoCredito");
				novoItem.setValor(String.valueOf(chktrabalhaComParcelamento.isChecked()));
				confTotemService.suscribir(novoItem);
			}
			
			confTotem = map.get("listarPassageiro");
			if (confTotem != null) {
				confTotem.setValor(String.valueOf(chktListarPassageiroUltimaPoltrona.isChecked()));
				confTotem.setFecmodif(new Date());
				confTotem.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("listarPassageiro");
				novoItem.setValor(String.valueOf(chktListarPassageiroUltimaPoltrona.isChecked()));
				confTotemService.suscribir(novoItem);
			}


			confTotem = map.get("empresasParaVenda");
			List<Empresa> lsEmpresas = empresaList.getListData();
			StringBuilder sb = new StringBuilder();
			for (Empresa empresa : lsEmpresas) {
				sb.append(empresa.getEmpresaId()).append(",");
			}

			if(!sb.toString().isEmpty()) {
				sb.delete(sb.length()-1, sb.length());
			}
					
			if (confTotem != null) {
				confTotem.setValor(sb.toString());
				confTotemService.actualizacion(confTotem);
			} else {
				novoItem = new ConfTotem();
				novoItem.setChave("empresasParaVenda");
				novoItem.setValor(sb.toString());

				confTotemService.suscribir(novoItem);
			}

			Messagebox.show(
					Labels.getLabel("busquedaConfTotemController.MSG.suscribirOK"),
					Labels.getLabel("busquedaConfTotemController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

		} catch (Exception ex) {
			log.error("", ex);
		}
	}
	public void onClick$btnAddEmpresa(Event ev) {
		
		Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
		if (cbiEmpresa != null) {
			Empresa empresa = (Empresa) cbiEmpresa.getValue();
			empresaList.addItemNovo(empresa);
		}
	}
	public void onClick$btnRemEmpresa(Event ev) {
		if (empresaList.getSelected() == null) {
			return;
		}
		empresaList.removeSelectedItem();

	}
	
	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

}
