package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.AgrupamentoParada;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.AgruparParadaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("editarCatalogoDeAgruparParadaController")
@Scope("prototype")
public class EditarCatalogoDeAgruparParadaController extends MyGenericForwardComposer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5631099822197596616L;

	@Autowired
	private AgruparParadaService agruparParadaService;
	private AgrupamentoParada agrupamentoParada;
	private MyListbox agrupamentoParadaList;
	private static Logger log = Logger.getLogger(EditarCatalogoDeAgruparParadaController.class);
	private Textbox descAgrupamentoParada;
	private Textbox cveAgrupamentoParada;

	public AgruparParadaService getAgruparParadaService() {
		return agruparParadaService;
	}

	public void setAgruparParadaService(AgruparParadaService agruparParadaService) {
		this.agruparParadaService = agruparParadaService;
	}

	public AgrupamentoParada getAgrupamentoParada() {
		return agrupamentoParada;
	}

	public void setAgrupamentoParada(AgrupamentoParada agrupamentoParada) {
		this.agrupamentoParada = agrupamentoParada;
	}

	public MyListbox getAgrupamentoParadaList() {
		return agrupamentoParadaList;
	}

	public void setAgrupamentoParadaList(MyListbox agrupamentoParadaList) {
		this.agrupamentoParadaList = agrupamentoParadaList;
	}

	public Textbox getDescAgrupamentoParada() {
		return descAgrupamentoParada;
	}

	public void setDescAgrupamentoParada(Textbox descAgrupamentoParada) {
		this.descAgrupamentoParada = descAgrupamentoParada;
	}

	public Textbox getCveAgrupamentoParada() {
		return cveAgrupamentoParada;
	}

	public void setCveAgrupamentoParada(Textbox cveAgrupamentoParada) {
		this.cveAgrupamentoParada = cveAgrupamentoParada;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		agrupamentoParada = (AgrupamentoParada) Executions.getCurrent().getArg().get("agrupamentoParada");
		agrupamentoParadaList = (MyListbox) Executions.getCurrent().getArg().get("agrupamentoParadaList");

	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		try {
			descAgrupamentoParada.getValue();
			cveAgrupamentoParada.getValue();
			agruparParadaService.suscribirActualizar(agrupamentoParada);
			agrupamentoParadaList.updateItem(agrupamentoParada);
			Messagebox.show(
					Labels.getLabel("editarCatalogoDeAgruparParadaController.MSG.suscribirOK"),
					Labels.getLabel("editarCatalogoDeAgruparParadaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			closeWindow();
		} catch (BusinessException ex) {
			Messagebox.show(
					ex.getLocalizedMessage(),
					Labels.getLabel("editarCatalogoDeAgruparParadaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarCatalogoDeAgruparParadaController.MSG.borrarPergunta"),
					Labels.getLabel("editarCatalogoDeAgruparParadaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				agruparParadaService.borrar(agrupamentoParada);

				Messagebox.show(
						Labels.getLabel("editarCatalogoDeAgruparParadaController.MSG.borrarOK"),
						Labels.getLabel("editarCatalogoDeAgruparParadaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				agrupamentoParadaList.removeItem(agrupamentoParada);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
			Clients.alert(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarCatalogoDeAgruparParadaController.window.title"),
					Messagebox.INFORMATION);
		}
	}

}
