package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Tab;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.ConexionCtrl;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaConf;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaCtrl;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaExcepcionPtoVta;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaExcepcionTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaCombinacion;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ConexionRutaConfService;
import com.rjconsultores.ventaboletos.service.ConexionRutaCtrlService;
import com.rjconsultores.ventaboletos.service.ConexionRutaExcepcionPtoVtaService;
import com.rjconsultores.ventaboletos.service.ConexionRutaExcepcionTipoPtoVtaService;
import com.rjconsultores.ventaboletos.service.ConexionRutaTramoCtrlService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.vo.parada.ConexionCtrlVO;
import com.rjconsultores.ventaboletos.vo.parada.ConexionRutaCtrlVO;
import com.rjconsultores.ventaboletos.vo.parada.ParadaVOConexionRuta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.combinacion.conexionruta.ConexionRutaCombinacionFactory;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexionRuta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexionRutaRemoveSelecionada;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderGeracaoConexionPorRuta;

@Controller("gerarConexionPorRutaController")
@Scope("prototype")
public class GerarConexionPorRutaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(GerarConexionPorRutaController.class);

	@Autowired
	private ConexionRutaCtrlService conexionRutaCtrlService;
	@Autowired
	private ConexionRutaConfService conexionRutaConfService;
	@Autowired
	private ConexionRutaTramoCtrlService conexionRutaTramoCtrlService;
	@Autowired
	private RutaService rutaService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private ConexionRutaExcepcionPtoVtaService conexionRutaRestricaoPtoVtaService;
	@Autowired
	private ConexionRutaExcepcionTipoPtoVtaService conexionRutaExcepcionTipoPtoVtaService;
	
	private MyListbox localidadesOrigemlList;
	private MyListbox localidadesDestinoList;
	private MyListbox  localidadesDestinoLinhaCList;
	private MyListbox localidadesLinhaASelecionadaList;
	private MyListbox localidadesLinhaBSelecionadaList;
	private MyListbox localidadesLinhaCSelecionadaList;
	private Tab resultadoCombinacao;
	private Button btnSalvar;
	private Button btnApagar;
	private Intbox txtTiempoMin;
	private Intbox txtTiempoMax;
	private Textbox txtDescricao;
	private MyListbox rutasAList;
	private MyListbox rutasBList;
	private MyListbox rutasCList;
	private MyListbox localidadesCombinadasList;
	private MyListbox localidadesComunsList;
	private MyListbox localidadesComunsDestinoCList;
	private MyListbox listEspCanal;
	private MyListbox listPuntoVenta;
	private List<Parada> lsLocalidadesComuns;
	private List<Parada> lsLocalidadesComunsLinhasBC;
	private Combobox cmbTipoPtovta;
	private Combobox cmbPtovta;
	private Combobox cmbRutaA;
	private Combobox cmbRutaB;
	private Combobox cmbRutaC;
	private List<TipoPuntoVenta> lsTipoPtovta;

	private List<Ruta> lsRutas;
	private List<ConexionCtrl> conexoesCtrl;
	List<ParadaVOConexionRuta> localidadesGeradas;
	private ConexionRutaConf conexionRutaConf;
	private MyListbox conexionRutaConfList;
	
	@Override
	public void doAfterCompose(Component comp) throws Exception {

		super.doAfterCompose(comp);
		txtTiempoMax.setConstraint("no empty");
		txtTiempoMin.setConstraint("no empty");
		txtDescricao.setConstraint("no empty");

		lsRutas = rutaService.obtenerTodos();
		lsTipoPtovta = tipoPuntoVentaService.obtenerTodos();

		conexionRutaConf = (ConexionRutaConf) Executions.getCurrent().getArg().get("conexionRutaConf");
		conexionRutaConfList = (MyListbox) Executions.getCurrent().getArg().get("conexionRutaConfList");
		
		Set<Parada> lsParadasOrigemA = new HashSet<Parada>();
		Set<Parada> lsParadasTodasOrigemA = new HashSet<Parada>();
		Set<Parada> lsParadasDestinoB = new HashSet<Parada>();
		Set<Parada> lsParadasTodasDestinoB = new HashSet<Parada>();
		Set<Parada> lsParadasDestinoC = new HashSet<Parada>();
		Set<Parada> lsParadasTodasDestinoC = new HashSet<Parada>();
		
		if (conexionRutaConf != null) {
			
			btnSalvar.setDisabled(false);
			btnApagar.setDisabled(false);
			
			txtDescricao.setValue(conexionRutaConf.getDescricao());
			txtTiempoMin.setValue(conexionRutaConf.getTiempoMin());
			txtTiempoMax.setValue(conexionRutaConf.getTiempoMax());
			List<Ruta> lsRutaA = new ArrayList<Ruta>();
			List<Ruta> lsRutaB = new ArrayList<Ruta>();
			List<Ruta> lsRutaC = new ArrayList<Ruta>();
			
			for (ConexionRutaExcepcionPtoVta conexionRutaExcepcionPtoVta : conexionRutaRestricaoPtoVtaService.buscarPorConexionConf(conexionRutaConf)) {
				listPuntoVenta.addItemNovo(conexionRutaExcepcionPtoVta.getPuntoVenta());
			}
			
			for (ConexionRutaExcepcionTipoPtoVta conexionRutaExcepcionTipoPtoVta: conexionRutaExcepcionTipoPtoVtaService.buscarPorConexionConf(conexionRutaConf)) {
				listEspCanal.addItemNovo(conexionRutaExcepcionTipoPtoVta.getTipoPtovta());
			}

			List<ConexionRutaCtrl> lsConexionRutaCtrl = conexionRutaCtrlService.buscarPorConexionConf(conexionRutaConf);
			for (ConexionRutaCtrl conexionRutaCtrl : lsConexionRutaCtrl) {
				Ruta ruta = rutaService.obtenerID(conexionRutaCtrl.getRutaOrigenId());
				carregarRuta(lsParadasTodasOrigemA, lsRutaA, ruta);
				
				ruta = rutaService.obtenerID(conexionRutaCtrl.getRutaDestinoId());
				carregarRuta(lsParadasTodasDestinoB, lsRutaB, ruta);
				
				if(conexionRutaCtrl.getRutaDestinoCId() != null) {
					ruta = rutaService.obtenerID(conexionRutaCtrl.getRutaDestinoCId());
					carregarRuta(lsParadasTodasDestinoC, lsRutaC, ruta);
				}
				
				lsParadasOrigemA.addAll(conexionRutaTramoCtrlService.buscarLocalidadesOrigem(conexionRutaCtrl));
				
				lsParadasDestinoB.addAll(conexionRutaTramoCtrlService.buscarLocalidadesDestino(conexionRutaCtrl));
				
				lsParadasDestinoC.addAll(conexionRutaTramoCtrlService.buscarLocalidadesDestinoC(conexionRutaCtrl));
			}
			
			localidadesLinhaASelecionadaList.setData(new ArrayList<Parada>(lsParadasOrigemA));
			localidadesOrigemlList.setData(new ArrayList<Parada>(lsParadasTodasOrigemA));
			localidadesLinhaBSelecionadaList.setData(new ArrayList<Parada>(lsParadasDestinoB));
			localidadesDestinoList.setData(new ArrayList<Parada>(lsParadasTodasDestinoB));
			localidadesLinhaCSelecionadaList.setData(new ArrayList<Parada>(lsParadasDestinoC));
			localidadesDestinoLinhaCList.setData(new ArrayList<Parada>(lsParadasTodasDestinoC));

			executarPesquisaLocalidadesOrigen();
			executarPesquisaLocalidadesDestino();
			executarPesquisaLocalidadesDestinoLinhasC();
			
			rutasAList.setData(lsRutaA);
			rutasBList.setData(lsRutaB);
			rutasCList.setData(lsRutaC);
			
			gerarCombinacao();
		}else{
			btnSalvar.setDisabled(true);
			btnApagar.setDisabled(true);
		}

		localidadesLinhaASelecionadaList.setItemRenderer(new RenderConexionRutaRemoveSelecionada(new EventListener() {

			@Override
			public void onEvent(Event arg0) throws Exception {

				Parada conexionRutaVO = (Parada) arg0.getTarget().getAttribute("data");
				for (Object objectParada : localidadesLinhaASelecionadaList.getListData()) {
					if (((Parada) objectParada).equals(conexionRutaVO)) {
						localidadesLinhaASelecionadaList.removeItem(conexionRutaVO);
						if(!localidadesOrigemlList.getListData().contains(conexionRutaVO)) {
							localidadesOrigemlList.addItemNovo(conexionRutaVO);
						}
						break;
					}
				}
			}
		}));
		localidadesLinhaBSelecionadaList.setItemRenderer(new RenderConexionRutaRemoveSelecionada(new EventListener() {

			@Override
			public void onEvent(Event arg0) throws Exception {

				Parada conexionRutaVO = (Parada) arg0.getTarget().getAttribute("data");
				for (Object objectParada : localidadesLinhaBSelecionadaList.getListData()) {
					if (((Parada) objectParada).equals(conexionRutaVO)) {
						localidadesLinhaBSelecionadaList.removeItem(conexionRutaVO);
						if(!localidadesDestinoList.getListData().contains(conexionRutaVO)) {
							localidadesDestinoList.addItemNovo(conexionRutaVO);
						}
						break;
					}
				}
				gerarLocalidadesComunsBC();
			}
		}));
		localidadesLinhaCSelecionadaList.setItemRenderer(new RenderConexionRutaRemoveSelecionada(new EventListener() {

			@Override
			public void onEvent(Event arg0) throws Exception {

				Parada conexionRutaVO = (Parada) arg0.getTarget().getAttribute("data");
				for (Object objectParada : localidadesLinhaCSelecionadaList.getListData()) {
					if (((Parada) objectParada).equals(conexionRutaVO)) {
						localidadesLinhaCSelecionadaList.removeItem(conexionRutaVO);
						if(!localidadesDestinoLinhaCList.getListData().contains(conexionRutaVO)) {
							localidadesDestinoLinhaCList.addItemNovo(conexionRutaVO);
						}
						break;
					}
				}
			}
		}));
		
		resultadoCombinacao.setSelected(false);
	}


	private void carregarRuta(Set<Parada> lsParadasTodas, List<Ruta> lsRuta, Ruta ruta) {
		if(!lsRuta.contains(ruta)) {
			lsRuta.add(ruta);
			for (RutaCombinacion rc : ruta.getRutaCombinacionList()) {
				if (rc.getTramo() != null) {
					lsParadasTodas.add(rc.getTramo().getOrigem());
					lsParadasTodas.add(rc.getTramo().getDestino());
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void onClick$btnSalvar(Event ev) throws Exception {
		
		if(!validarItensSalvar()) {
			return;
		}

		if(conexionRutaConf != null && conexionRutaConf.getConexionRutaConfId() != null) {
			conexionRutaConfService.excluirConfiguracao(conexionRutaConf, false);
		}
		
		gerarCombinacao();
		List<ConexionRutaCtrlVO> lsConexionRutaCtrl = ConexionRutaCombinacionFactory.extrairConexionRutaCtrl(localidadesGeradas);
		
		boolean itemNovo = false;
		if(conexionRutaConf == null) {
			 conexionRutaConf = new ConexionRutaConf();
			 itemNovo = true;
		}
		
		conexionRutaConf.setDescricao(txtDescricao.getText());	
		conexionRutaConf.setTiempoMin(txtTiempoMin.getValue());
		conexionRutaConf.setTiempoMax(txtTiempoMax.getValue());
		
		List<TipoPuntoVenta> canalVentas = listEspCanal.getListData();
		List<PuntoVenta> puntoVentas = listPuntoVenta.getListData();
		
		conexionRutaConf = conexionRutaConfService.salvarConfiguracao(conexionRutaConf, canalVentas, puntoVentas, conexoesCtrl, lsConexionRutaCtrl, localidadesGeradas);
		
		if(itemNovo) {
			conexionRutaConfList.addItemNovo(conexionRutaConf);
		}else {
			conexionRutaConfList.updateItem(conexionRutaConf);
		}
		
		mostraMensagem(Labels.getLabel("editarConexionPorRutaController.MSG.suscribirOK"));

		closeWindow();
	}
	
	public void onClick$btnApagar(Event ev) throws Exception {
		
		int resp = Messagebox.show(
				Labels.getLabel("editarConexionPorRutaController.MSG.PerguntaApagar"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			conexionRutaConfService.excluirConfiguracao(conexionRutaConf, true);
			conexionRutaConfList.removeItem(conexionRutaConf);
			mostraMensagem(Labels.getLabel("editarConexionPorRutaController.MSG.ApagarOK"));
			closeWindow();
		}
		
	}

	public void onClick$btnPesquisaPermissao(Event ev) throws InterruptedException {
		executarPesquisaLocalidadesOrigen();
	}

	public void onClick$btnPesquisaLocalidadesDestino(Event ev) throws InterruptedException {
		executarPesquisaLocalidadesDestino();
	}

	private void executarPesquisaLocalidadesOrigen() throws InterruptedException {

		localidadesCombinadasList.clear();
		localidadesComunsList.setModel(new ListModelList(new ArrayList<Parada>()));
		try {

			localidadesOrigemlList.setItemRenderer(new RenderConexionRuta(new EventListener() {

				@Override
				public void onEvent(Event arg0) throws Exception {
					Parada parada = (Parada) arg0.getTarget().getAttribute("data");
					if (arg0.getTarget().getAttribute("tipo").equals(RenderConexionRuta.BOTAO_ADICIONAR_PERMISSAO)) {
						if (localidadesLinhaASelecionadaList.getListData().isEmpty()) {
							localidadesLinhaASelecionadaList.addItemNovo(parada);
						} else {
							for (Object objectParada : localidadesLinhaASelecionadaList.getListData()) {
								if (localidadesLinhaASelecionadaList.getListData().contains(parada) ||  (getLsLocalidadesComuns() != null && getLsLocalidadesComuns().contains(parada))) {
									return;
								}
								if (!((Parada) objectParada).equals(parada)) {
									localidadesLinhaASelecionadaList.addItemNovo(parada);
									break;
								}
							}
						}
						localidadesOrigemlList.removeItem(parada);
					}
				}
			}));
			gerarLocalidadesComuns();
		} catch (Exception e) {
			log.error("", e);
		}

	}

	private void executarPesquisaLocalidadesDestino() throws InterruptedException {
		
		localidadesCombinadasList.clear();
		localidadesComunsDestinoCList.setModel(new ListModelList(new ArrayList<Parada>()));

		try {
			localidadesDestinoList.setItemRenderer(new RenderConexionRuta(new EventListener() {

				@Override
				public void onEvent(Event arg0) throws Exception {
					Parada parada = (Parada) arg0.getTarget().getAttribute("data");
					if (arg0.getTarget().getAttribute("tipo").equals(RenderConexionRuta.BOTAO_ADICIONAR_PERMISSAO)) {
						if (localidadesLinhaBSelecionadaList.getListData().isEmpty()) {
							localidadesLinhaBSelecionadaList.addItemNovo(parada);
						} else {
							for (Object objectParada : localidadesLinhaBSelecionadaList.getListData()) {
								if (localidadesLinhaBSelecionadaList.getListData().contains(parada) ||   (getLsLocalidadesComuns() != null && getLsLocalidadesComuns().contains(parada))) {
									return;
								}
								if (!((Parada) objectParada).equals(parada)) {
									localidadesLinhaBSelecionadaList.addItemNovo(parada);
									break;
								}
							}
						}
						gerarLocalidadesComunsBC();
					}
				}
			}));
			gerarLocalidadesComuns();
		} catch (Exception e) {
			log.error("", e);
		}

	}
	
	private void executarPesquisaLocalidadesDestinoLinhasC() throws InterruptedException {
		
		localidadesCombinadasList.clear();
		
		try {
			localidadesDestinoLinhaCList.setItemRenderer(new RenderConexionRuta(new EventListener() {

				@Override
				public void onEvent(Event arg0) throws Exception {
					Parada parada = (Parada) arg0.getTarget().getAttribute("data");
					if (arg0.getTarget().getAttribute("tipo").equals(RenderConexionRuta.BOTAO_ADICIONAR_PERMISSAO)) {
						if (localidadesLinhaCSelecionadaList.getListData().isEmpty()) {
							localidadesLinhaCSelecionadaList.addItemNovo(parada);
						} else {
							for (Object objectParada : localidadesLinhaCSelecionadaList.getListData()) {
								if (localidadesLinhaCSelecionadaList.getListData().contains(parada) ||   (getLsLocalidadesComunsLinhasBC() != null && getLsLocalidadesComunsLinhasBC().contains(parada))) {
									return;
								}
								if (!((Parada) objectParada).equals(parada)) {
									localidadesLinhaCSelecionadaList.addItemNovo(parada);
									break;
								}
							}
						}
						localidadesDestinoLinhaCList.removeItem(parada);
					}
				}
			}));
			gerarLocalidadesComuns();
		} catch (Exception e) {
			log.error("", e);
		}

	}

	private void gerarLocalidadesComuns() {

		gerarLocalidadesComunsAB();
		gerarLocalidadesComunsBC();

	}
	
	@SuppressWarnings("unchecked")
	private void gerarLocalidadesComunsAB() {
		Set<Parada> lsParadas = new HashSet<Parada>(0);
		lsParadas = new HashSet<Parada>(localidadesOrigemlList.getListData());
		ArrayList<Parada> paradasDuplicadas = new ArrayList<Parada>(lsParadas);
		paradasDuplicadas.retainAll(localidadesDestinoList.getListData());

		localidadesLinhaASelecionadaList.getListData().removeAll(paradasDuplicadas);
		localidadesLinhaBSelecionadaList.getListData().removeAll(paradasDuplicadas);

		localidadesComunsList.setModel(new ListModelList(paradasDuplicadas));
		lsLocalidadesComuns = new ArrayList<Parada>(paradasDuplicadas);
	}
	
	@SuppressWarnings("unchecked")
	private void gerarLocalidadesComunsBC() {
		Set<Parada> lsParadas = new HashSet<Parada>(0);
		lsParadas = new HashSet<Parada>(localidadesDestinoList.getListData());
		ArrayList<Parada> paradasDuplicadas = new ArrayList<Parada>(lsParadas);
		paradasDuplicadas.retainAll(localidadesDestinoLinhaCList.getListData());
		localidadesLinhaCSelecionadaList.getListData().removeAll(paradasDuplicadas);
		
		List<Parada> lsLinhaBSelecionadas = new ArrayList<Parada>(localidadesLinhaBSelecionadaList.getListData());
		paradasDuplicadas.retainAll(lsLinhaBSelecionadas);
		
		localidadesComunsDestinoCList.setModel(new ListModelList(paradasDuplicadas));
		lsLocalidadesComunsLinhasBC = new ArrayList<Parada>(paradasDuplicadas);
		
	}
	
	public void onSelect$cmbRutaA(Event ev) throws Exception {
	}

	public void onSelect$cmbRutaB(Event ev) throws Exception {
	}

	public void onClick$btnCombinarTrechos(Event ev) throws InterruptedException {
		if (lsLocalidadesComuns == null || lsLocalidadesComuns.isEmpty()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.selecionarConexion"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}

		gerarCombinacao();		
	}
	
	private boolean validarItensSalvar() throws InterruptedException {
		

		if (localidadesCombinadasList.getListData().isEmpty()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.selecionarConexion"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return false;
		}
		
		txtTiempoMax.getValue();
		txtTiempoMin.getValue();
		
		return true;
	}

	public void onClick$btnNovoCanalVenta(Event ev) throws InterruptedException {
		
		if(cmbTipoPtovta.getSelectedItem() == null){
			return;
		}
		TipoPuntoVenta ptovta = (TipoPuntoVenta) cmbTipoPtovta.getSelectedItem().getValue();
		
		if (listEspCanal.getListData().contains(ptovta)) {
			Messagebox.show(
					Labels.getLabel("editarPricingEspecificoOcupacionController.MSG.noPricingEspecificoCanalJaCadastrado"),
					Labels.getLabel("busquedaPricingEspecificoController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else if(ptovta != null) {
			listEspCanal.addItemNovo(ptovta);
		}
		
		cmbTipoPtovta.setValue("");
	}
	
	public void onClick$btnApagarCanalVenta(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarConexionPergunta"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (listEspCanal.getSelected() != null) {
				listEspCanal.removeItem((TipoPuntoVenta) listEspCanal.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.selecionarConexion"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}
	
	public void onClick$btnNovoPuntoVenta(Event ev) throws InterruptedException {

		if(cmbPtovta.getSelectedItem() == null){
			return;
		}
		PuntoVenta puntoVenta = (PuntoVenta) cmbPtovta.getSelectedItem().getValue();		
		
		if (listPuntoVenta.getListData().contains(puntoVenta)) {
			Messagebox.show(
					Labels.getLabel("editarConexionPorRutaController.MSG.noPuntoVentaJaCadastrado"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else if(puntoVenta != null) {
			listPuntoVenta.addItemNovo(puntoVenta);
		}
		
		cmbTipoPtovta.setValue("");
	}
	
	public void onClick$btnApagarPuntoVenta(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarPuntoVentaPergunta"),
				Labels.getLabel("editarConexionPorRutaController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (listPuntoVenta.getSelected() != null) {
				listPuntoVenta.removeItem((PuntoVenta) listPuntoVenta.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.selecionarConexion"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}
	
	@SuppressWarnings("unchecked")
	public void onClick$btnNovoRutaA(Event ev) throws InterruptedException {
		
		if (!validarLinhaJaSelecionada()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.rutaJaSelecionada"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		
		if(cmbRutaA.getSelectedItem() == null){
			return;
		}
		Ruta rutaA = (Ruta) cmbRutaA.getSelectedItem().getValue();
		
		if (rutasAList.getListData().contains(rutaA)) {
			Messagebox.show(
					Labels.getLabel("editarPricingEspecificoOcupacionController.MSG.noPricingEspecificoCanalJaCadastrado"),
					Labels.getLabel("busquedaPricingEspecificoController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else {
			if(rutaA.getRutaId() == -1){
				rutasAList.clear();
			}else {
				List<Ruta> canaisVenta = rutasAList.getListData();
				for (Ruta rutaAux : canaisVenta) {
					if(rutaA.getRutaId() == -1){
						rutasAList.clear();
						rutasAList.addItemNovo(rutaAux);
						rutaA = null;
						break;
					}
				}
			}
			Set<Parada> lsParadas = new HashSet<Parada>(0);
			lsParadas.addAll(localidadesLinhaASelecionadaList.getListData());
			if(rutaA != null) {
				rutaA = rutaService.obtenerID(rutaA.getRutaId());
				if (rutaA.getRutaCombinacionList() != null) {
					for (RutaCombinacion rc : rutaA.getRutaCombinacionList()) {
						if (rc.getTramo() != null) {
							lsParadas.add(rc.getTramo().getOrigem());
							lsParadas.add(rc.getTramo().getDestino());
						}
					}
				}
				
				localidadesOrigemlList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));
				localidadesLinhaASelecionadaList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));
				
				rutasAList.addItemNovo(rutaA);
			}			
		}
		executarPesquisaLocalidadesOrigen();
		cmbRutaA.setValue("");
	}
	
	public void onClick$btnApagarRutaA(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarConexionPergunta"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (rutasAList.getSelected() != null) {
				rutasAList.removeItem((Ruta) rutasAList.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.borrarRutaPergunta"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}

	public void onClick$btnNovoRutaB(Event ev) throws InterruptedException {

		if (!validarLinhaJaSelecionada()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.rutaJaSelecionada"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		
		if(cmbRutaB.getSelectedItem() == null){
			return;
		}
		Ruta rutaB = (Ruta) cmbRutaB.getSelectedItem().getValue();
		
		if (rutasBList.getListData().contains(rutaB)) {
			Messagebox.show(
					Labels.getLabel("editarPricingEspecificoOcupacionController.MSG.noPricingEspecificoCanalJaCadastrado"),
					Labels.getLabel("busquedaPricingEspecificoController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else {
			if(rutaB.getRutaId() == -1){
				rutasBList.clear();
			}else {
				@SuppressWarnings("unchecked")
				List<Ruta> canaisVenta = rutasBList.getListData();
				for (Ruta rutaAux : canaisVenta) {
					if(rutaB.getRutaId() == -1){
						rutasBList.clear();
						rutasBList.addItemNovo(rutaAux);
						rutaB = null;
						break;
					}
				}
			}
			Set<Parada> lsParadas = new HashSet<Parada>(0);
			lsParadas.addAll(localidadesLinhaBSelecionadaList.getListData());
			if(rutaB != null) {
				rutaB = rutaService.obtenerID(rutaB.getRutaId());
				if (rutaB.getRutaCombinacionList() != null) {
					for (RutaCombinacion rc : rutaB.getRutaCombinacionList()) {
						if (rc.getTramo() != null) {
							lsParadas.add(rc.getTramo().getOrigem());
							lsParadas.add(rc.getTramo().getDestino());
						}
					}
				}
				localidadesDestinoList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));			
				localidadesLinhaBSelecionadaList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));
				
				rutasBList.addItemNovo(rutaB);
			}			
		}
		executarPesquisaLocalidadesDestino();
		cmbRutaB.setValue("");
		
	}
	
	public void onClick$btnApagarRutaB(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarConexionPergunta"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (rutasBList.getSelected() != null) {
				rutasBList.removeItem((Ruta) rutasBList.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.borrarRutaPergunta"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}
	public void onClick$btnNovoRutaC(Event ev) throws InterruptedException {
	

		if (!validarLinhaJaSelecionada()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.rutaJaSelecionada"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		
		if(cmbRutaC.getSelectedItem() == null){
			return;
		}
		Ruta rutaC = (Ruta) cmbRutaC.getSelectedItem().getValue();
		
		if (rutasCList.getListData().contains(rutaC)) {
			Messagebox.show(
					Labels.getLabel("editarPricingEspecificoOcupacionController.MSG.noPricingEspecificoCanalJaCadastrado"),
					Labels.getLabel("busquedaPricingEspecificoController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else {
			if(rutaC.getRutaId() == -1){
				rutasCList.clear();
			}else {
				@SuppressWarnings("unchecked")
				List<Ruta> canaisVenta = rutasCList.getListData();
				for (Ruta rutaAux : canaisVenta) {
					if(rutaC.getRutaId() == -1){
						rutasCList.clear();
						rutasCList.addItemNovo(rutaAux);
						rutaC = null;
						break;
					}
				}
			}
			Set<Parada> lsParadas = new HashSet<Parada>(0);
			lsParadas.addAll(localidadesLinhaCSelecionadaList.getListData());
			if(rutaC != null) {
				rutaC = rutaService.obtenerID(rutaC.getRutaId());
				if (rutaC.getRutaCombinacionList() != null) {
					for (RutaCombinacion rc : rutaC.getRutaCombinacionList()) {
						if (rc.getTramo() != null) {
							lsParadas.add(rc.getTramo().getOrigem());
							lsParadas.add(rc.getTramo().getDestino());
						}
					}
				}
				localidadesDestinoLinhaCList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));				
				localidadesLinhaCSelecionadaList.setData(new ListModelList(new ArrayList<Parada>(lsParadas)));
				
				rutasCList.addItemNovo(rutaC);
			}			
		}
		executarPesquisaLocalidadesDestinoLinhasC();
		cmbRutaC.setValue("");
	}
	public void onClick$btnApagarRutaC(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarConexionPergunta"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (rutasCList.getSelected() != null) {
				rutasCList.removeItem((Ruta) rutasCList.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.borrarRutaPergunta"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}
	public List<Ruta> getLsRutas() {
		return lsRutas;
	}

	public void setLsRutas(List<Ruta> lsRutas) {
		this.lsRutas = lsRutas;
	}
	/**
	 * @return the lsPtovata
	 */
	public List<TipoPuntoVenta> getLsTipoPtovta() {
		return lsTipoPtovta;
	}

	/**
	 * @param lsPtovata
	 *            the lsPtovata to set
	 */
	public void setLsPtovata(List<TipoPuntoVenta> lsTipoPtovta) {
		this.lsTipoPtovta = lsTipoPtovta;
	}
	
	private void mostraMensagem(String msg) throws InterruptedException {
		Messagebox.show(msg, Labels.getLabel("editarConexionController.window.title"), Messagebox.OK, Messagebox.INFORMATION);
	}

	public List<Parada> getLsLocalidadesComuns() {
		return lsLocalidadesComuns;
	}

	public void setLsLocalidadesComuns(List<Parada> lsLocalidadesComuns) {
		this.lsLocalidadesComuns = lsLocalidadesComuns;
	}
	
	public List<Parada> getLsLocalidadesComunsLinhasBC() {
		return lsLocalidadesComunsLinhasBC;
	}

	public void setLsLocalidadesComunsLinhasBC(List<Parada> lsLocalidadesComunsLinhasBC) {
		this.lsLocalidadesComunsLinhasBC = lsLocalidadesComunsLinhasBC;
	}


	@SuppressWarnings("unchecked")
	private void gerarCombinacao() {

		
		localidadesGeradas = new ArrayList<ParadaVOConexionRuta>();
		conexoesCtrl = new ArrayList<ConexionCtrl>();
		
		List<Parada> listParada1 = localidadesLinhaASelecionadaList.getListData();
		List<Ruta> rutasEixoA = rutasAList.getListData();
		List<Ruta> rutasEixoB = rutasBList.getListData();
		List<Ruta> rutasEixoC = rutasCList.getListData();
		List<Parada> listParada4 = localidadesLinhaBSelecionadaList.getListData();
		List<Parada> listParadasC = localidadesLinhaCSelecionadaList.getListData();
		List<ConexionCtrlVO> conexoesCtrlVO = new ArrayList<ConexionCtrlVO>(0);

		if(rutasEixoC.isEmpty()) {
			ConexionRutaCombinacionFactory.gerarCombinacionEntre2Eixos(listParada1,rutasEixoA, rutasEixoB, getLsLocalidadesComuns(), listParada4, rutasEixoA, rutasEixoB, localidadesGeradas, conexoesCtrlVO );
		}else {
			ConexionRutaCombinacionFactory.gerarCombinacionEntre3Eixos(listParada1,rutasEixoA, rutasEixoB, getLsLocalidadesComuns(), listParada4,listParadasC, rutasEixoA, rutasEixoB,rutasEixoC,localidadesGeradas, conexoesCtrlVO );
		}
		
		for (ConexionCtrlVO conexionCtrlVO : conexoesCtrlVO) {
			conexoesCtrl.add(new ConexionCtrl(conexionCtrlVO.getOrigenId(), conexionCtrlVO.getDestinoId(), conexionCtrlVO.getGrupo()));
		}

		localidadesCombinadasList.setData(localidadesGeradas);
		localidadesCombinadasList.setItemRenderer(new RenderGeracaoConexionPorRuta());
		
		resultadoCombinacao.setSelected(true);
		
		btnSalvar.setDisabled(Boolean.FALSE);

	}

	@SuppressWarnings("unchecked")
	private boolean validarLinhaJaSelecionada() {
		
		List<Ruta> lsRutaA = rutasAList.getListData();
		List<Ruta> lsRutaB = rutasBList.getListData();
		List<Ruta> lsRutaC = rutasCList.getListData();
		
		Ruta rutaA  = (Ruta) (cmbRutaA.getSelectedItem() != null ? cmbRutaA.getSelectedItem().getValue() : null);
		Ruta rutaB  = (Ruta) (cmbRutaB.getSelectedItem() != null ? cmbRutaB.getSelectedItem().getValue() : null);
		Ruta rutaC  = (Ruta) (cmbRutaC.getSelectedItem() != null ? cmbRutaC.getSelectedItem().getValue() : null);
		
		for (Ruta rA : lsRutaA) {
			if(rutaA != null) {
				if(rA.equals(rutaA)) {
					return false;
				}
			}
			if(rutaB != null) {
				if(rA.equals(rutaB)) {
					return false;
				}
			}
			if(rutaC != null) {
				if(rA.equals(rutaC)) {
					return false;
				}
			}
		
		}
		for (Ruta rb : lsRutaB) {
			if(rutaA != null) {
				if(rb.equals(rutaA)) {
					return false;
				}
			}
			if(rutaB != null) {
				if(rb.equals(rutaB)) {
					return false;
				}
			}
			if(rutaC != null) {
				if(rb.equals(rutaC)) {
					return false;
				}
			}
		
		}
		for (Ruta rc : lsRutaC) {
			if(rutaA != null) {
				if(rc.equals(rutaA)) {
					return false;
				}
			}
			if(rutaB != null) {
				if(rc.equals(rutaB)) {
					return false;
				}
			}
			if(rutaC != null) {
				if(rc.equals(rutaC)) {
					return false;
				}
			}
		
		}
		return true;
	}
}

